#include <iostream>
#include "File.h"
#include "compiler/Tokenizer.h"
#include "Exception.h"
#include "data/Stack.h"
#include "code/Script.h"
#include "compiler/Compiler.h"
#include "code/FloatData.h"
#include "code/BoolData.h"
#include "code/Instruction.h"

using namespace std;

int main(int argc, char** argv) 
{        
    File f("tests/vars.snuvi");
    if(f.exists())
    {
        Compiler c(f.read());
        Script sc;
        c.compile(sc);
        sc.execute();
    }
    else
    {
        cout << "no" << endl;
    }

    return 0;
}



