#ifndef INSTRUCTION_H
#define INSTRUCTION_H

#include "../data/Stack.h"
#include "Data.h"
#include <memory>

class Instruction
{
public:
    Instruction(int args, void (*f) (int, Stack<shared_ptr<Data>>&, shared_ptr<Data>), shared_ptr<Data> data);
    virtual ~Instruction();
    
    void execute(Stack< shared_ptr<Data> >& st) const;
private:
    int args;
    void (*function) (int, Stack<shared_ptr<Data>>&, shared_ptr<Data>);
    shared_ptr<Data> data;
};

#endif

