#ifndef SCRIPT_H
#define SCRIPT_H

#include "../data/ArrayList.h"
#include "../data/Stack.h"
#include "Data.h"
#include "Instruction.h"
#include <memory>

using namespace std;

class Script
{
public:
    Script();
    virtual ~Script();
    
    void execute();
    
    ArrayList<Instruction*>& getInstructions();
private:
    ArrayList<Instruction*> instructions;
    Stack<shared_ptr<Data>> dataStack;
};

#endif

