#ifndef DATA_H
#define DATA_H

#include <string>
#include <iostream>
#include "../Exception.h"

using namespace std;

class Data
{
public:
    Data();
    Data(const Data& orig);
    virtual ~Data();

    virtual float getFloat() const;
    virtual void setFloat(float f);
    
    virtual bool getBool() const;
    virtual void setBool(bool b);
    
    virtual string getString() const;
    virtual void setString(string s);
    
    virtual void print(std::ostream& os) const;
private:
};

std::ostream& operator<<(std::ostream& os, const Data& d);

#endif

