#include "Instruction.h"

Instruction::Instruction(int args, void (*f) (int, Stack<shared_ptr<Data>>&, shared_ptr<Data>), shared_ptr<Data> data) : args(args), function(f), data(data)
{
}

Instruction::~Instruction()
{
}

void Instruction::execute(Stack< shared_ptr<Data> >& st) const
{
    function(args, st, data);
}

